#!/bin/sh
SSD_VERSION=0730.00


PCKG_INST_PATH="/Library/Receipts/SentinelSystemDriver.pkg"
SDK_PCKG_PATH="/Library/Receipts/SentinelKeysSDK.pkg"
LICMGR_PCKG_PATH="/Library/Receipts/SentinelKeysLicenseManager.pkg"
SKPI_PCKG_PATH="/Library/Receipts/SentinelKeysProtectionInstaller.pkg"
SNTL_COMM_PATH="/Applications/Safenet Sentinel"
SUPRO_PCKG_PATH=/Library/Receipts/SentinelSuperPro*
SUPRO_DRIVER_PATH=/Library/Receipts/SentinelDriver1.0.0*
FRMWRK_INST_PATH="/Library/Frameworks/Sentinel.framework"

UPRO_PCKG_PATH="/Library/Receipts/SentinelUltraPro(English).pkg"
UPRO_SPI_PATH="/Library/Receipts/SentinelProtectionInstaller.pkg"
UPRO_DRIVER_PATH="/Library/Receipts/SentinelDriver1.0.0.2.pkg"
UPRO_FRMWRK_PATH="/Library/Receipts/SentinelFramework.pkg"
UPRO_KM_PATH="/Library/Receipts/SentinelKeyManager(English).pkg"

ISDRIVER=0

dash_ln="----------------------------------------------------------------------"

echo $dash_ln
echo "              Sentinel System Driver version 7.3.0 Un-installation Script"
echo "                   Copyright (C) 2006 SafeNet, Inc."
echo "                         All rights reserved."
echo $dash_ln
echo

echo "This script will uninstall the Sentinel System Driver.";echo

### Check whether Sentinel System Driver package is installed 
   [ -d "$PCKG_INST_PATH" ]
   if [ $? -ne 0 ]
   then
      echo "Sentinel System Driver package not installed.";echo
      exit
   fi

### Check if the current user has administrative rights
   id | grep "admin" > /dev/null 2>&1
   if [ $? -ne 0 ]
   then 
       echo "To uninstall this package you should have root permission."
       echo "Uninstallation aborted."
       echo 
       exit
   fi
  
### Check if some other application is also using this package.
    
[ -f "/Library/Receipts/SafenetSentinelProduct.Info" ]
if [ $? -eq 0 ]
then
    sudo chmod 777 /Library/Receipts/SafenetSentinelProduct.Info
    ssd_version=`grep SentinelSystemDriver /Library/Receipts/SafenetSentinelProduct.Info | cut -d = -f 2 | cut -d : -f 1`
    if [ $ssd_version = 0730.00 ]
    then
       current_inst=`grep SentinelSystemDriver /Library/Receipts/SafenetSentinelProduct.Info | cut -d = -f 3`
       if [ $current_inst -gt 1 ]
       then  
          echo "Unable to uninstall the Sentinel System Driver due to other users/applications dependency!!"      
          decrement_inst=1
          count_SSD=`expr $current_inst - $decrement_inst`
          sudo echo "/SentinelSystemDriver/" > /tmp/SNTLCMD
          sudo echo "d" >> /tmp/SNTLCMD; echo "w" >> /tmp/SNTLCMD; echo "q" >> /tmp/SNTLCMD
          (sudo grep "SentinelSystemDriver" /Library/Receipts/SafenetSentinelProduct.Info && sudo ed /Library/Receipts/SafenetSentinelProduct.Info < /tmp/SNTLCMD) > /dev/null 2>&1 
          echo "SentinelSystemDriver="$SSD_VERSION":Count="$count_SSD  >>  /Library/Receipts/SafenetSentinelProduct.Info
          rm -rf /tmp/SNTLCMD
          exit
       fi 
      
       if [ $current_inst = 1 ]
       then  
          decrement_inst=1
          count_SSD=`expr $current_inst - $decrement_inst`
          sudo echo "/SentinelSystemDriver/" > /tmp/SNTLCMD
          sudo echo "d" >> /tmp/SNTLCMD; echo "w" >> /tmp/SNTLCMD; echo "q" >> /tmp/SNTLCMD
          (sudo grep "SentinelSystemDriver" /Library/Receipts/SafenetSentinelProduct.Info && sudo ed /Library/Receipts/SafenetSentinelProduct.Info < /tmp/SNTLCMD) > /dev/null 2>&1
          echo "SentinelSystemDriver="$SSD_VERSION":Count="$count_SSD  >>  /Library/Receipts/SafenetSentinelProduct.Info
          rm -rf /tmp/SNTLCMD
       fi
   fi
sudo chmod 775 /Library/Receipts/SafenetSentinelProduct.Info
fi

### Remove UninstallSSD.sh
    sudo rm -rf "$SNTL_COMM_PATH"/Common\ Files/Sentinel\ System\ Driver/UninstallSSD.sh > /dev/null 2>&1

### Check whether Ultrapro SDK package is installed
    [ -d "$UPRO_PCKG_PATH" ]
    if [ $? -eq 0 ]
    then
      echo "Cannot uninstall the Sentinel System Driver because some other Package is using it.";echo
      ISDRIVER=1
    fi

### Check whether Ultrapro SPI package is installed
if [ $ISDRIVER = 0 ]
then
    [ -d "$UPRO_SPI_PATH" ]
    if [ $? -eq 0 ]
    then
      echo "Cannot uninstall the Sentinel System Driver because some other Package is using it.";echo
      ISDRIVER=1
    fi
fi

### Check whether Ultrapro Framework package is installed
if [ $ISDRIVER = 0 ]
then  
  [ -d "$UPRO_FRMWRK_PATH" ]
    if [ $? -eq 0 ]
    then
      echo "Cannot uninstall the Sentinel System Driver because some other Package is using it.";echo
      ISDRIVER=1
    fi
fi

### Check whether Ultrapro KM package is installed
if [ $ISDRIVER = 0 ]
then  
  [ -d "$UPRO_KM_PATH" ]
    if [ $? -eq 0 ]
    then
      echo "Cannot uninstall the Sentinel System Driver because some other Package is using it.";echo
      ISDRIVER=1
    fi
fi

### Check whether Sentinel Keys SDK is installed
if [ $ISDRIVER = 0 ]
then
    [ -d "$SDK_PCKG_PATH" ]
    if [ $? -eq 0 ]
    then
     echo "Cannot uninstall the Sentinel System Driver because some other Package is using it.";echo
     ISDRIVER=1
    fi
fi

### Check whether Sentinel Keys License Manager is installed
if [ $ISDRIVER = 0 ]
then
    [ -d "$LICMGR_PCKG_PATH" ]
    if [ $? -eq 0 ]
    then
      echo "Cannot uninstall the Sentinel System Driver because some other Package is using it.";echo
      ISDRIVER=1
    fi
fi

### Check whether Sentinel Keys Protection Installer is installed
if [ $ISDRIVER = 0 ]
then  
  [ -d "$SKPI_PCKG_PATH" ]
    if [ $? -eq 0 ]
    then
      echo "Cannot uninstall the Sentinel System Driver because some other Package is using it.";echo
      ISDRIVER=1 
    fi
fi

### Checking whether SuperPro is installed
if [ $ISDRIVER = 0 ]
then  
 [ -d $SUPRO_PCKG_PATH ]
   if [ $? -eq 0 ]
   then
     echo "Cannot uninstall the Sentinel System Driver because some other Package is using it.";echo
     ISDRIVER=1
   fi
fi

### Checking whether SuperPro Driver is installed
if [ $ISDRIVER = 0 ]
then  
 [ -d $SUPRO_DRIVER_PATH ]
   if [ $? -eq 0 ]
   then
     echo "Cannot uninstall the Sentinel System Driver because some other Package is using it.";echo
     ISDRIVER=1
   fi
fi

if [ $ISDRIVER = 0 ]
then
# Unload the Sentinel System Driver
 sudo kextstat | grep Sentinel > /dev/null 2>&1
  if [ $? = 0 ]; then
  echo "Unload the Sentinel System Driver..."; echo
  touch /tmp/temp > /dev/null 2>&1
  ( sudo kextunload /System/Library/Extensions/Sentinel.kext | tee /tmp/temp > /dev/null 2>&1 )
  if [ `wc -c < /tmp/temp` = 0 ]; then
    echo "Authorization Failure !!!"
    rm -rf /tmp/temp
  fi

  grep fail /tmp/temp > /dev/null 2>&1
  if [ $? = 0 ]; then
    echo "Failed to unload the driver.";echo
    rm /tmp/temp
  else
    echo "Sentinel System Driver unloaded successfully."; echo   
  fi
 fi

### Remove Sentinel.kext
    [ -d /System/Library/Extensions/Sentinel.kext ]
    if [ $? = 0 ]; then
      sudo rm -rf /System/Library/Extensions/Sentinel.kext
    fi

  echo "Sentinel System Driver version 7.3.0 uninstalled successfully."; echo
 
### Remove Framework
    sudo rm -rf "$FRMWRK_INST_PATH" > /dev/null 2>&1
fi

sudo rm -rf "$SNTL_COMM_PATH"/Common\ Files/Sentinel\ System\ Driver > /dev/null 2>&1

### Check if /Applications/Safenet\ Sentinel/Common\ Files is empty
    val=`ls /Applications/Safenet\ Sentinel/Common\ Files` 
    if [ "$val" = "" ]
    then
        sudo rm -rf /Applications/Safenet\ Sentinel/Common\ Files > /dev/null 2>&1
    fi

### Check if /Applications/Safenet\ Sentinel is empty
    val=`ls /Applications/Safenet\ Sentinel`
    if [ "$val" = "" ]
    then
       sudo rm -rf /Applications/Safenet\ Sentinel > /dev/null 2>&1
    fi

### Remove Package entry
    sudo rm -rf "/Library/Receipts/SentinelSystemDriver.pkg" > /dev/null 2>&1
    if [ $? -ne 0 ]
    then
        echo "Error occured while uninstalling Sentinel System Driver package.";echo
        exit
    fi    

